package projekat3;

import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JComboBox;

public class BazaStudenata {
    
    private String nazivFakulteta;
    private List <Student> bp;

    public BazaStudenata(String nazivFakulteta) {
        this.nazivFakulteta = nazivFakulteta;
        this.bp = new ArrayList<>();
    }

    public void setBp(List<Student> bp) {
        this.bp = bp;
    }

    public List<Student> getBp() {
        return bp;
    }   
    
    public void upisiStudenta(Student x){
        this.bp.add(x);
        System.out.println("Student: "+x.getImePrezime()+" je dodat u bazu podataka!");
    }
    public void prikaziStudenteCB(JComboBox jcb){
        Iterator <Student>it = this.bp.iterator();
        while(it.hasNext()){
            Student temp = it.next();
            jcb.addItem(temp.getImePrezime() + temp.getBrojIndeksa());            
        }
    }
    public void prikaziStudente(){
        Iterator <Student>it = this.bp.iterator();
        while(it.hasNext()){
            Student temp = it.next();
            System.out.println("Student: "+temp.getImePrezime()+" "+temp.getBrojIndeksa());
        }
    }
    //2016/215689
    public String generisiIndeks(String upisanGodina){
        String indeks="";
        Random sb = new Random();
        int broj = 100000 + sb.nextInt(99999);
        indeks = upisanGodina+"/"+broj;
        return indeks;
    }
    public boolean proveriJMBG(String jmbg){
        boolean status=true;
        if(jmbg.length()==13){
            for(int i=0;i<jmbg.length();i++){
                if(!Character.isDigit(jmbg.charAt(i))){
                    status = false;
                    break;                    
                }
            }
        }else{
            status = false;
        }
        return status;
    }
    public void ucitajPodatke(String adresaFajla, JComboBox jcb){
        
        try {
            FileInputStream fis = new FileInputStream(adresaFajla);//
            BufferedInputStream bis = new BufferedInputStream(fis);
            DataInputStream dis = new DataInputStream(bis);
            StringTokenizer st;
            String []temp=null;
            Student s = null;
            
            while(dis.available()!=0){
                temp = dis.readLine().split("#");
                s = new Student(temp[2],temp[0],temp[1]);
                this.bp.add(s);
            }
            System.out.println("broj studenta u bazi je: "+this.bp.size());
        } catch (FileNotFoundException ex) {
            Logger.getLogger(BazaStudenata.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(BazaStudenata.class.getName()).log(Level.SEVERE, null, ex);
        }        
        this.prikaziStudenteCB(jcb);
    }
    
    public void upisFajl(String nazivfajla){
        try {
            FileWriter fw = new FileWriter(nazivfajla);
            PrintWriter pw = new PrintWriter(fw);
            Iterator <Student>it = this.bp.iterator();
            while(it.hasNext()){
                String x="";
                Student temp =  it.next();
                x = temp.getImePrezime()+"#"+temp.getJMBG()+"#"+temp.getBrojIndeksa();
                pw.println(x);
            }
            pw.close();fw.close();
        } catch (IOException ex) {
            Logger.getLogger(BazaStudenata.class.getName()).log(Level.SEVERE, null, ex);            
        }
    }
    
}
